// control_a.h
// $Id: control_a.h,v 1.5.2.11 2005/01/15 01:29:39 acher Exp $

void setup_scan(void);
void select_subch(uchar n, uchar m);
void select_prog(uchar n,uchar m);
void init_control(void);
void dfire_tune();
uchar Cdfire_wait(uchar waitc,uchar sub);
void scan_next(void);
void get_ensemble(void);
void get_programs(void);
void get_programs_1(void);
void get_subch_info(void);
void do_scan();
void show_dabstate();
void Cshow_name(uchar n) ;
void show_prognum013();
void get_figs(uchar t, uchar con, uchar tex);
void setz();
void clear_sids(void);
void small_wait(void);
void store_program(uchar n);
uchar recall_program(uchar n, uchar waitn);
void recall_chan_sub(void);
uchar get_dfire(uchar n);
void Cprintf_index(uchar n);

void set_equalizer(uchar, uchar, uchar);
void acquire_figs(void);
void Cdfire_start_cmd(char*);

uchar print_current_name(void);
void print_spaces(uchar i);
void browse_banks(void);
void show_prognum(void);
void show_bank_leds(void);
void show_num_subch(void);

void menu_timer_calls1(void);
void menu_bank_menu(void);
void show_lrarrows(void);
void set_cd_msg(void);
void blink(void);
void rdi_select_all(void);
// -------------------------------------------------------------------
// storage_ax.asm

void Ccurrent_2_scratch(uchar _current_2_scratch_PARM_1);
void Cscratch_2_current(uchar _scratch_2_current_PARM_1);
void Cscratch_2_NVC(uchar _scratch_2_NVC_PARM_1);
void Cscratch_2_NVS(uchar _scratch_2_NVS_PARM_1, uchar _scratch_2_NVS_PARM_2);
void CNVC_2_scratch(uchar _NVC_2_current_PARM_1);
void CNVS_2_scratch(uchar _NVS_2_scratch_PARM_1, uchar _NVS_2_scratch_PARM_2);

void Ccurrent_2_NVC(void);

uchar find_banked(void);


// -------------------------------------------------------------------

extern xdata char dfc_get_subch[0];
extern code char dfc_scan[0];
extern code char dfc_tune[0];
extern code char dfc_set_equalizer[0];
extern code char dfc_select_subch[0];
extern xdata char dfc_get_figs[0];
extern code char dfc_get_dabstatus[0];

#define STR_ENSEMBLE 0
#define STR_CURRENT_NAME 1
#define STR_TUNING 2
#define STR_NULL 3
#define STR_SCAN 4
#define STR_GINFO 5
#define STR_STORED 6
#define STR_CHANNELS 7

#define STR_SWAP_WITH 8
#define STR_BANDSEL 9
#define STR_DIGITALOUTPUT 10
#define STR_AUDIORDI 11
#define STR_BROWSEBANKS 12
#define STR_SETTINGS 13
#define STR_BASS 14
#define STR_MID 15

#define STR_TREBLE 16
#define STR_BAND3 17
#define STR_LBAND 18
#define STR_NOSTORAGE 19
#define STR_BROWSEKEYS1 20
#define STR_BROWSEKEYS2 21
#define STR_LCD 22
#define STR_SCANENTER 23

#define STR_BAND3LBAND 24
#define STR_EQUALIZER 25 
#define STR_SELECT 26
#define STR_VERSION 27
#define STR_VENDOR 28
#define STR_ABORTED 29

#define STR_LBMODE0 32
#define STR_LBMODE1 33
