	.include "defines_a.asm"
	
	.if KEY12 = 1

	KEY_ONE = 1
	KEY_SIX = 6
	KEY_VOLPLUS = 11
	KEY_VOLMINUS = 9
	KEY_PROGPLUS = 10
	KEY_PROGMINUS = 12
;	KEY_SCAN = 7
	KEY_BANK = 7
;	KEY_SCANOTHER = 8
	KEY_MENU = 8
	KEY_QUALITY = 6


	.else

	KEY_ONE = 17
	KEY_SIX = 22

	KEY_VOLPLUS = 4
	KEY_VOLMINUS = 2
	KEY_PROGPLUS = 8
 	KEY_PROGMINUS = 1	

 	KEY_MENU = 6	; 
	KEY_QUALITY = 5
	KEY_BANK = 5 ; right/down

	.endif


	MENU_NORMAL = 0
	MENU_QUALITY = 1
	MENU_BROWSE = 2
	MENU_SCAN = 3
	MENU_EQUALIZER = 4
	MENU_SETTINGS = 5

; MENU_SETTINGS

	MENU_SPDIF = 0
	MENU_LCD = 1
	MENU_LBMODE = 2

; MENU_EQUALIZER

	MENU_BASS = 0
	MENU_MID = 1
	MENU_TREBLE = 2



; register alias

	ar0 = 0x00
        ar1 = 0x01
	ar2 = 0x02
        ar3 = 0x03
        ar4 = 0x04
        ar5 = 0x05
        ar6 = 0x06
        ar7 = 0x07
       

; HW regs
	xilinx0 = 0x8800
	xilinx2 = 0x8802
	xilinx3 = 0x8803
	_dfire	= 0x8400

	BUFFPTR_DAB = 768

	_cd_free	= 0x87f9
	_cd_data	= 0x87f8
	_cd_msg	= 0x87fe
	_dc_data = 0x87fa
	_dc_free = 0x87fb 
	_cpubuf = 0x87c0

; memory
	_frequ_h = 0x1e60

 .if 1
	_scratch0 = 0x2500
	_scratch1 = 0x2520
	_scratch2 = 0x2540

	_current_name = 0x2580

	_all_subchannels = 0x2300
 .endif 
; string defines

	STR_ENSEMBLE = 0
	STR_CURRENT_NAME = 1
	STR_TUNING = 2
	STR_NULL = 3
	STR_SCAN = 4
	STR_GINFO = 5
	STR_STORED = 6
	STR_CHANNELS = 7

	STR_SWAP_WITH = 8
	STR_BANDSEL = 9
	STR_DIGITALOUTPUT = 10
 	STR_AUDIORDI = 11
 	STR_BROWSEBANKS = 12
 	STR_BROWSESELECT = 13
 	STR_BASS = 14
 	STR_MID = 15

 	STR_TREBLE = 16
 	STR_BAND3 = 17
 	STR_LBAND = 18	
 	STR_NOSTORAGE = 19	
	STR_BROWSEKEYS1 = 20
	STR_BROWSEKEYS2 = 21
	STR_LCD = 22
	STR_SCANENTER = 23
	STR_BAND3LBAND = 24
	STR_EQUALIZER = 25
	STR_SELECT = 26

	STR_VERSION = 27
	STR_VENDOR = 28
	STR_ABORTED = 29
	STR_SWAP_WITH_1 = 30
	STR_CLEAR_ALL = 31
	STR_LBMODE0 = 32
	STR_LBMODE1 = 33
	
	SPDIF_SEL = 0x80

	NV_BANK0 = 0x40
	NV_BANK1 = 0x41
	NV_BANK2 = 0x42
	NV_BANK3 = 0x43
	NV_BANK4 = 0x44
	NV_BANK5 = 0x45

	NV_SUBCH = 1
	NV_CHANNEL = 2
	NV_BAND = 3
	NV_STORAGE = 4


	NV_VOL = 0x10
	NV_BASS = 0x11
	NV_MID = 0x12
	NV_TREBLE = 0x13
	
	NV_CONTROL = 0x20
	NV_LBMODE = 0x21