// dfire.c 270699 GA
//
// DFIRE communication
//
// $Id: dfire_a.c,v 1.5 2000/05/30 21:30:36 acher Exp $

#include "regezusb.h"
#pragma SAVE
#pragma NOOVERLAY

// ------------ DAB-Module registers


#define MSGREG_DAB	0x3ff		// Message from DAB Module to Controller
#define MSGREG_CPU	0x3fe		// Message from Controller to DAB Module
#define DATA_TYPE	0x3fd		// Data Type of BUFFPTR_FIC 0:empty 1:FIC 2:PAD 
#define FREEPTR_DAB	0x3fb		// First free field in circular buffer DAB Module -> Controller
#define DATAPTR_DAB	0x3fa		// Lowest used field in circular buffer DAB Module -> Controller
#define BUFFPTR_DAB	768		// circular buffer DAB Module -> Controller
#define FREEPTR_CPU	0x3f9		// First free field in circular buffer Controller -> DAB Module
#define DATAPTR_CPU	0x3f8		// Lowest used field in circular buffer -> DAB Module
#define BUFFPTR_CPU	960		// circular buffer Controller -> DAB Module
#define BUFSIZE_CPU	32		// size in bytes
#define BUFFPTR_DAB	768		// circular buffer DAB Module -> Controller
#define BUFSIZE_DAB	192		// size in bytes
#define BUFFPTR_FIC	0		// FIC/PAD Databuffer
#define BUFSIZE_FIC	768		// size in bytes

typedef unsigned char uchar;
void poscursor(char x, char y);
extern char msg_wait;

extern void wait_0_1ms();
#define DFIRE_ADDR 0x8400

xdata at 0x8802 volatile uchar xilinx2; // LCD CMD
xdata at 0x8803 volatile uchar xilinx3;  // LCD DATA

extern uchar dline;
void printf(char *s);
void printh(uchar s);

