#include "regezusb.h"

typedef unsigned char uchar;

#if 1  // LED-MODE
#define FPGA_CLK (0x80+1)
#define FPGA_DATA (0x40+2)
#else 
#define FPGA_CLK 0x01
#define FPGA_DATA 0x02
#endif
/*-------------------------------------------------------------------*/
//! FPGA download via USB
void download_fpga(void)
{
  uchar n,m,x;

  for(n=4;n<64;n++)
    {
      x=OUT2BUF[n];
     
      for(m=0;m<8;m++) // PA0: CCLK, PA1:DIN
	{
	  if (x&128)
	    {
	      _asm
		mov  dptr,#_OUTA
		mov  a,#FPGA_DATA
		movx  @dptr,a
		mov  a,#FPGA_DATA+FPGA_CLK
		movx  @dptr,a
		_endasm;
	    }
	  else
	    {
	      _asm
		mov  dptr,#_OUTA
		clr  a
		movx  @dptr,a
		mov  a,#FPGA_CLK
		movx  @dptr,a
		_endasm;
	    }
	  x=x+x;
	}
    }
}

