; menu_a.asm
; Menu standalone
; $Id: menu_a.asm,v 1.1.2.28 2005/01/15 01:29:40 acher Exp $
	.module menu_a
	.include "regezusb.asm"
	.include "defines_t.asm"

	.globl _show_prognum013
	.globl _show_sid
	.globl _Cprintf_index
	.globl _printf_index
	.globl _printf_index00
	.globl _printf_index01
	.globl _printf_index_acc
	.globl _printf_index00_acc
	.globl _printf_index01_acc
	.globl _browse_banks
	.globl _menu_timer_calls1
	.globl _menu_bank_menu
	.globl _default_key_handler
	.globl _handle_scan_menu
	.globl _enter_browse_menu
	.globl _enter_scan_menu
	.globl _handle_equalizer_menu
	.globl _handle_spdif_menu
	.globl _handle_lcd_menu
	.globl _get_channel_info
	.globl _store_lcd_cont
	.globl _show_menutext
	.globl _handle_lbmode_menu
  
	.globl _printf_index_PARM_1
	.globl _printf_index00_PARM_1
	.globl _printf_index01_PARM_1

	.globl _lbmode

	.area DSEG    (DATA)
_printf_index_PARM_1:
_printf_index00_PARM_1:
_printf_index01_PARM_1:
	.ds 1
_menu_tmp:
	.ds 1

	.area CSEG    (CODE)
_Cprintf_index:
	mov _printf_index_PARM_1,dpl
	sjmp _printf_index

	lcall _poscursor00
	sjmp _printf_index
;----------------------------------------------------------------------
_printf_index01_acc:
	mov _printf_index_PARM_1,a
	sjmp _printf_index01
;----------------------------------------------------------------------
_printf_index00_acc:
	mov _printf_index_PARM_1,a
;----------------------------------------------------------------------
_printf_index00:
	lcall _poscursor00
	sjmp _printf_index
;----------------------------------------------------------------------
_printf_index01:
	lcall _poscursor01
;----------------------------------------------------------------------
; void printf_index(uchar i)
_printf_index:
	mov a,_printf_index_PARM_1
_printf_index_acc:
	mov dptr,#_str_table

	add a,acc
	add a,dpl
	jnc _ppi
	inc DPH
_ppi:      
	mov dpl,a
	movx a,@dptr
	mov (_printf_PARM_1 + 1),a

	inc dptr
	movx a,@dptr
	mov (_printf_PARM_1 + 0),a

	ljmp _printf
;----------------------------------------------------------------------
; waits for a small time or exits if key is pressed
_wait_key_time:
	mov _key,#0
	mov r0,#50
_wkt1:
	mov a,_key
	jnz _wkt2
	lcall _wait_1000
	djnz r0,_wkt1
_wkt2:
	ret
;----------------------------------------------------------------------
_show_prognum013:
	mov r0,#12
	mov r1,#0
	lcall _poscursor_r01
	lcall _putc32
	ljmp _show_prognum
;----------------------------------------------------------------------
; r0: high, r1: low
_show_sid:
	mov _printh_PARM_1,r0
	lcall _printh

	mov _printh_PARM_1,r1
	ljmp _printh

 .if 1
;----------------------------------------------------------------------
; choose storage, return value: a: 1 ->, 2 sel with <-, 4: 1
; 0: exited with Menu 
; destroys 
_select_storage:
	sjmp _sels_12
_sels_loop:
	mov _wait_key_release_PARM_1,#1
	lcall _wait_key_release
	mov _key,_xkey
	mov a,_key
	jz _sels_loop
	cjne a,#KEY_MENU,_sels_1
	mov a,#0
	ret
_sels_1:
	cjne a,#KEY_PROGPLUS,_sels_2
	inc _storage
	sjmp _sels_10

_sels_2:
	cjne a,#KEY_PROGMINUS,_sels_3
	dec _storage
	sjmp _sels_10
_sels_3:
	cjne a,#KEY_VOLMINUS,_sels_4
	mov a,#2
	ret
_sels_4:
	cjne a,#KEY_VOLPLUS,_sels_5
	mov a,#1
	ret
_sels_5:
	cjne a,#KEY_ONE,_sels_6
	mov a,#4
	ret

_sels_6:
	sjmp _sels_loop

_sels_10:
	mov a,_storage
	jnz _sels_11
	mov _storage,#24
	sjmp _sels_12
_sels_11:
	clr c
	subb a,#25
	jc _sels_12
	mov _storage,#1

_sels_12:
	lcall _clear_lcd

;	mov _recall_program_PARM_1,_storage
	mov dpl,_storage
	mov _recall_program_PARM_2,#0	; dont wait
	push _storage
	lcall _recall_program
	pop _storage
	push DPL
	lcall _poscursor00

	mov  a,_storage
        dec a
        mov b,#0x06
       	div ab
	anl a,#3
	mov _bank,a
	lcall _show_bank_leds

	pop DPL		; return state from recall_program
	clr a
	cjne a,DPL,_sels_13
	mov _printf_index_PARM_1,#STR_NOSTORAGE 
	sjmp _sels_14

_sels_13:	
	lcall _show_channel
	lcall _putc32
	lcall _putc32
	lcall _putc32
	lcall _putc32
	
;	mov a,#'S
;	lcall _putc_acc
;	inc _subch
;	mov a,_subch
;	lcall _printi_acc2
	lcall _putc32
	mov r0,_sidh
	mov r1,_sidl
	lcall _show_sid
	dec _subch
   	mov _printf_index_PARM_1,#STR_CURRENT_NAME

_sels_14:
	lcall _show_prognum013
	lcall _printf_index01

	ljmp _sels_loop

 .endif	
;----------------------------------------------------------------------
_storage_clear_all:
	mov _key,#0
	lcall _clear_lcd
	mov a,#STR_CLEAR_ALL
	lcall _printf_index00_acc
	lcall _wait_key_release0
_sc0:
	mov a,_key
	jz _sc0
	cjne a,#KEY_VOLMINUS,_brb0
	lcall _clear_lcd
	mov dptr,#_scratch0
	mov r0,#32
	mov a,#0xff
	lcall _fill_mem

	mov r7,#24
_sc2:
	push ar7

	mov _scratch_2_NVS_PARM_1,#0
	mov _scratch_2_NVS_PARM_2,r7
	lcall _poscursor00
	mov _printh_PARM_1,_scratch_2_NVS_PARM_2
	lcall _printh
	lcall _scratch_2_NVS
	pop ar7
	djnz r7,_sc2	
	ret
;----------------------------------------------------------------------
_browse_banks:
 .if 1
	mov _current_2_scratch_PARM_1,#2	; save current in scratch 2
	lcall _current_2_scratch
	mov a,_storage
	cjne a,#255,_brb00a
	mov _storage,#1
_brb00a:
	lcall _wait_key_time
_brb_loop:	
	lcall _select_storage
	cjne a,#0,_brb1
_brb0:						; Menu pressed -> aborted
	lcall _clear_lcd
	mov a,#STR_ABORTED
	lcall _printf_index00_acc
	lcall _wait_3000
	lcall _wait_3000
	mov _current_2_scratch_PARM_1,#2
	ljmp _scratch_2_current			; restore

_brb1:
	cjne a,#1,_brb1a
						; -> pressed, tune	
	mov a,_band
	anl a,#254
	jnz _brb_loop
	mov a,_subch
	clr c
	subb a,#17
	jnc _brb_loop
	lcall _wait_1000
	lcall _clr_line0
	mov _menu,#0
	ljmp _recall_chan_sub	
_brb1a:
	cjne a,#2,_brb2a
_brb2:
						; <- swap selected
	lcall _wait_1000
	mov _key,#0
	mov _xkey,#0
	lcall _clr_line0
	mov a,#STR_SWAP_WITH
	lcall _printf_index01_acc
	mov a,#STR_SWAP_WITH_1
	lcall _printf_index00_acc
	lcall _wait_key_time
	mov _menu_tmp,_storage
	mov _NVS_2_scratch_PARM_1,#3
	mov _NVS_2_scratch_PARM_2,_storage
	lcall _NVS_2_scratch
	sjmp _brb_loop2
_brb2a:
	cjne a,#4,_brb_loop
						; 1 pressed
	ljmp _storage_clear_all
_brb_loop2:
	lcall _select_storage
	cjne a,#0,_brb3		; Menu pressed
	sjmp _brb0
_brb3:
	cjne a,#2,_brb_loop2
	lcall _clear_lcd
	mov _NVS_2_scratch_PARM_1,#1
	mov _NVS_2_scratch_PARM_2,_storage
	lcall _NVS_2_scratch

;	mov _scratch_2_NVS_PARM_1,#1
	mov _NVS_2_scratch_PARM_2,_menu_tmp
	lcall _scratch_2_NVS

	mov _scratch_2_NVS_PARM_1,#3
	mov _NVS_2_scratch_PARM_2,_storage
	lcall _scratch_2_NVS

	ajmp _brb_loop
 .endif
	ret		

;----------------------------------------------------------------------
_menu_timer_calls1:
	mov a,_timer_n+1
	add a,#254
	jnc _mtc3
	mov a,_bank

	jnb acc.7,_mtc1
	swap a
	anl a,#3
	mov _bank,a
	lcall _clrtn
	ljmp _show_bank_leds

_mtc1:
	mov a,_menu	; reset to menu 0
	jz _mtc3
	cjne a,#MENU_QUALITY,_mtc2
_mtc3:
	ret
_mtc2:
	ljmp _restore_menu0

;----------------------------------------------------------------------
; handles bank and menu keys
_menu_bank_menu:
	mov a,_key
	cjne a,#KEY_BANK,_mbm1
	mov a,_menu
	jz _mbm0a
	lcall _restore_menu0
.if KEY12-1
_mbm0a:
	sjmp _mbm1

	.else
	
_mbm0a:
	mov a,_bank		
	jnb acc.7,_mbm0b
	inc a			; bank=(bank&0xf0)+((bank+1)&3);
	anl a,#0xf3
	mov _bank,a
	sjmp _mbm0c
_mbm0b:
	mov r0,a		; bank=(128+(bank<<4))+((bank+1)&3);
	inc acc
	anl a,#3
	swap a
	orl a,r0
	swap a
	orl a,#128		
	mov _bank,a	
	.endif
_mbm0c:
	lcall _wait_key_release0
	ljmp _clrtn

_mbm1:
	ret
;----------------------------------------------------------------------
; VOL +/-, Prog +/-, 1-6
_default_key_handler:

	mov a,_key
	cjne a,#KEY_VOLPLUS,_dak1          ; VOL +
	mov a,_xvolume
	clr c
	subb a,#60
	jnc _dak2a
	add a,#61
	sjmp _dak2
_dak1:
	cjne a,#KEY_VOLMINUS,_dak3         ; Vol -
	mov a,_xvolume
	jz _dak2a
	dec a
_dak2:
	anl a,#63
	mov _xvolume,a
_dak2a:
	lcall _set_volume
_dak2b:
	lcall _clrtn
	lcall _wait_1000
	mov _tn,#0
	ret
_dak3:
	jz _dak4

	.if KEY12

	add a,#255-KEY_SIX
	jc _dak4            
	mov r0,_menu
	cjne r0,#MENU_QUALITY,_dak3aa
	mov a,_key
	dec a
	mov _quality_mode,a
	mov _key,#0
	ret

_dak3aa:
	mov _menu,#0		; storage keys 1-6
	mov _last_key,_key
	mov _wait_key_release_PARM_1,#20
	lcall _wait_key_release
	push DPL
;	lcall _wait_3000

	mov a,_bank
	anl a,#3
	mov b,#6
	mul ab
	add a,_last_key
	mov r0,a		; r0=prognr

	mov _last_key,#0
	pop ACC			; timeout value
	add a,#236
	jnc _dak3a       ; no timeout
	
;	mov _store_program_PARM_1,r0	; long keypress -> store
	mov dpl,r0	; long keypress -> store
	lcall _store_program
	mov a,_bank
	anl a,#0xf
	mov _bank,a
	lcall _show_ensemble_name_num
	ljmp _wait_key_release0
_dak3a:	
;	mov _recall_program_PARM_1,r0		; short key press -> recall
	mov dpl,r0		; short key press -> recall
	mov _recall_program_PARM_2,#2
	lcall _recall_program
	ljmp _recall_chan_sub

	.endif	
_dak4:
	mov a,_key
	cjne a,#KEY_PROGPLUS,_dak4a	; P+
	lcall _increment_subch
	sjmp _dak2b
_dak4a:		
	cjne a,#KEY_PROGMINUS,_dak5	; P-
	lcall _decrement_subch
	sjmp _dak2b
_dak5:
	ret
;----------------------------------------------------------------------
_get_max_channel:
	mov r0,#37	; max for band3
	mov a,_band
	jz _gmc		; band3
	mov r0,#22	; max for bandl
_gmc:
	ret
;----------------------------------------------------------------------
; SCAN
_handle_scan_menu:
	mov _current_2_scratch_PARM_1,#2
	lcall _current_2_scratch
_dbk0:
	mov a,_key
	jz _dbk0
	cjne a,#KEY_VOLMINUS,_dbk1
	mov a,_band
	jz _dbk2
	clr a
	mov _band,a
	mov _channel,a
	sjmp _dbk2
_dbk1:
	cjne a,#KEY_VOLPLUS,_dbk3
	mov a,_band
	jnz _dbk2
	mov _band,#1
	mov _channel,#0
_dbk2:
	lcall _do_scan
	ljmp _restore_menu0
_dbk3:
	cjne a,#KEY_PROGPLUS,_dbk4

	lcall _clear_lcd			; enter ensemble

	mov a,#STR_BANDSEL

	lcall _printf_index_acc
	lcall _wait_key_release0
	lcall _wait_key_time
	lcall _clear_lcd
_dbk3a:
	lcall _clr_line1
	lcall _show_frequency
	lcall _show_band	
	lcall _wait_1000
	lcall _wait_1000
	lcall _get_max_channel
	mov _key,#0
_dbk3b:
	mov a,_key
	cjne a,#KEY_VOLMINUS,_dbk3c
	mov a,_channel
	jz _dbk3ba
	dec a
	mov _channel,a
	sjmp _dbk3a
_dbk3ba:
	mov _channel,r0
	sjmp _dbk3a
_dbk3c:
	cjne a,#KEY_VOLPLUS,_dbk3d
	mov a,_channel
	cjne a,ar0,_dbk3ca
	mov _channel,#0
	sjmp _dbk3a
_dbk3ca:
	inc _channel
	sjmp _dbk3a
_dbk3d:
	cjne a,#KEY_PROGPLUS,_dbk3e
	mov a,_band
	xrl a,#1			; invert BAND
	mov _band,a
	clr a
	mov _channel,a
	mov _key,a
	lcall _wait_key_release0	
	sjmp _dbk3a

_dbk3e:
	cjne a,#KEY_PROGMINUS,_dbk3f
	mov _storage,#255
	lcall _clear_sids
	ljmp _recall_chan_sub
_dbk3f:
	cjne a,#KEY_MENU,_dbk3b
	ljmp _scratch_2_current
	
_dbk4:
	ret
;----------------------------------------------------------------------
; Equalizer
_handle_equalizer_menu:

	mov a,_menu
	anl a,#15
	add a,#_eq_val
	mov r0,a
	mov a,@r0
	mov r2,a
	mov a,_key
	cjne a,#KEY_VOLPLUS,_dck1
	mov a,r2
	add a,#16
	jnc _dck2a
	ret
_dck1:
	cjne a,#KEY_VOLMINUS,_dck2
	mov a,r2
	add a,#240
	jc _dck2a
_dck3:
	ret
_dck2:
	cjne a,#KEY_PROGMINUS,_dck3
	mov a,#128
_dck2a:
	mov @r0,a
	mov a,r0
	clr c
	subb a,#_eq_val
	mov _equalizer_PARM_1,a
	lcall _equalizer
	ljmp _clrtn

;----------------------------------------------------------------------
_store_lcd_cont:
	mov a,_lcd_cont
	orl a,#0x10+8
	mov dptr,#xilinx0
	movx @dptr,a
	mov _nvram_bank,#NV_BANK0
	mov _nvram_addr,#NV_CONTROL
	mov _nvram_val,_lcd_cont
	ljmp _write_nvram
;----------------------------------------------------------------------
; SPDIF Selection
_handle_spdif_menu:
	mov a,_key
	cjne a,#KEY_VOLPLUS,_ddk1
	orl _lcd_cont,#SPDIF_SEL
	sjmp _ddk2
_ddk1:
	cjne a,#KEY_VOLMINUS,_ddk3
	anl _lcd_cont,#~SPDIF_SEL
_ddk2:
	lcall _store_lcd_cont
	sjmp _hlb2a
_ddk3:
	ret
;----------------------------------------------------------------------
; LB-Mode Selection
_handle_lbmode_menu:
	mov a,_key
	cjne a,#KEY_VOLPLUS,_hlb1
	mov _lbmode,#1
	sjmp _hlb2
_hlb1:
	cjne a,#KEY_VOLMINUS,_hlb3
	mov _lbmode,#0				; 0->Canada
_hlb2:
	mov _nvram_bank,#NV_BANK0
	mov _nvram_addr,#NV_LBMODE
	mov _nvram_val,_lbmode
	lcall _write_nvram

_hlb2a:
	lcall _show_menutext
	lcall _wait_key_release0
	lcall _wait_1s
	ljmp _restore_menu0
_hlb3:
	ret
;----------------------------------------------------------------------
_show_enter_menu:
	mov _key,#0
	lcall _printf_index00
	inc _printf_index_PARM_1
	lcall _printf_index
	lcall _wait_key_release0
	ljmp _wait_3000
;----------------------------------------------------------------------
; BROWSE SELECTION
_enter_browse_menu:
	mov _printf_index_PARM_1,#STR_BROWSEKEYS1
	lcall _show_enter_menu
	ljmp _browse_banks
;----------------------------------------------------------------------
; SCAN
_enter_scan_menu:
	mov _printf_index_PARM_1,#STR_SCANENTER	
	lcall _show_enter_menu
	ljmp _handle_scan_menu
;----------------------------------------------------------------------
; LCD Contrast
_handle_lcd_menu:
	mov a,_key
	cjne a,#KEY_VOLPLUS,_dfk1
	mov a,_lcd_cont
	anl a,#15
	cjne a,#15,_dfk2
	ret
_dfk2:
	mov a,_lcd_cont		
	inc a
	sjmp _dfk3
_dfk1:
	cjne a,#KEY_VOLMINUS,_dfk6
	mov a,_lcd_cont
	anl a,#15
	cjne a,#9,_dfk5
	ret
_dfk5:
	mov a,_lcd_cont
	dec a
_dfk3:
	mov _lcd_cont,a
	lcall _show_menutext
	lcall _wait_1000
	lcall _clrtn
	lcall _store_lcd_cont
_dfk6:
	ret
;----------------------------------------------------------------------
; subchannel info job
_get_channel_info:
	mov a,_key
	orl a,_menu
	jnz _gci1       ; !key && !menu
	mov a,_tn
	anl a,#31
	cjne a,#31,_gci1       ; tn&63=63

;	lcall _blink

	mov r7,_num_sub            ; r7=old_num_sub
	mov _supress_bar,#1

	push ar7
	lcall _get_subch_info_1
	pop ar7

	mov a,_num_sub
	jz _gci2		; num_sub=0
	cjne a,#16,_gci3	; num_sub!=16
_gci2:
	mov _num_sub,r7		; num_sub=old_num_sub
_gci3:
	mov _supress_bar,#0

	mov a,r7
	cjne a,_num_sub,_gci4  ; num_sub!=old_num_sub
;	lcall _blink
_gci1:	

	ret
_gci4:
	lcall _wait_1s
;	mov _select_prog_PARM_1,_subch
	mov dpl,_subch
	mov _select_prog_PARM_2,#0
	ljmp _select_prog

;----------------------------------------------------------------------
; dptr: table
_print_menu_text:
	mov a,_menu
	anl a,#15
	movc a,@a+dptr
	ljmp _printf_index_acc
;----------------------------------------------------------------------
_show_ensemble_name_num:
	mov _show_name_PARM_1,_subch
	lcall _show_name
	ljmp _show_prognum013

;----------------------------------------------------------------------
_show_menutext:
	lcall _clr_line0
	lcall _clr_line1
	lcall _poscursor00
	
	mov a,_menu
	swap a
	anl a,#15
	
	cjne a,#MENU_NORMAL,_smt1
;		------------------------------
; MENU_NORMAL
	mov a,_menu
	anl a,#15
	mov dptr,#_menu_text_0
	movc a,@a+dptr

	cjne a,#128,_smt0a
	sjmp _show_ensemble_name_num
_smt0a:
	cjne a,#129,_smt0b	
	ljmp _show_dabstate
_smt0b:
	lcall _printf_index_acc

	mov a,#STR_SELECT
	ljmp _printf_index01_acc
;		--------------------------
_smt1:	
	cjne a,#MENU_EQUALIZER,_smt2
; MENU_EQUALIZER
	mov dptr,#_menu_text_4
	lcall _print_menu_text
	lcall _show_lrarrows
	mov a,_menu
	anl a,#15
	add a,#128
	mov _equalizer_PARM_1,a
	ljmp _equalizer
;		--------------------------
_smt2:
	cjne a,#MENU_SETTINGS,_smt3
; MENU_SETTINGS
	mov dptr,#_menu_text_5
	lcall _print_menu_text
	mov a,_menu
	anl a,#15
	cjne a,#MENU_SPDIF,_smt2a
; SPDIF

	mov a,#STR_AUDIORDI
	lcall _printf_index01_acc
	mov a,_lcd_cont
	rl a
	ljmp _show_selection

_smt2a:
	cjne a,#MENU_LCD,_smt3
; MENU_LCD
	lcall _clr_line1
	mov a,_lcd_cont
	anl a,#15
	add a,#248
	push acc
	lcall _printi_acc1
	mov _bargraph_PARM_1,#(15-8)*2
	mov _bargraph_PARM_2,#4
	mov _bargraph_PARM_3,#3
	lcall _bargraph
	pop acc
	add a,acc
	mov _bargraph_PARM_1,a
	mov _bargraph_PARM_3,#1
	ljmp _bargraph
_smt3:
	cjne a,#MENU_LBMODE,_smt4
; MENU_LBMODE
	mov a,#STR_LBMODE1
	lcall _printf_index01_acc
	mov a,_lbmode
	ljmp _show_selection
_smt4:	
	ret
;------------------------------------------------------
_show_selection:
	mov r1,#1
	mov r0,#14
	jb acc.0,_right_sel
	mov r0,#1
_right_sel:
	lcall _poscursor_r01
	mov a,#'*
	ljmp _putc_acc
;------------------------------------------------------