; control_ax.asm
; DFIRE control functions in pure assembler
; $Id: control_ax.asm,v 1.8.2.24 2005/01/15 01:29:39 acher Exp $

	.module control_ax
	.include "regezusb.asm"	
	.include "defines_t.asm"

	.globl _clear_sids,_get_dfire
	.globl _setz,_transfer_frequ
	.globl _Cdfire_wait
	.globl _dfire_wait
	.globl _get_subch_info,_dfire_get_msg
	.globl _get_subch_info_1
	.globl _dfire_tune,_init_control
	.globl _Cshow_name
	.globl _show_name,_setup_scan
	.globl _show_dabstate
	.globl _decrement_subch,_increment_subch
	.globl _acquire_figs
	.globl _set_equalizer
	.globl _Cdfire_start_cmd
	.globl _dfire_start_cmd

	.globl _print_current_name
	.globl _equalizer
	.globl _show_channel
	.globl _show_name_raw

	.globl _scan_next
	.globl _show_prognum
	.globl _show_bank_leds
	.globl _show_num_subch
	.globl _get_audio_info

	.globl _blink,_fill_mem
	.globl _show_frequency
	.globl _set_cd_msg
	.globl _rdi_select_all

	.globl _get_dfire_PARM_1
	.globl _transfer_frequ_PARM_1
	.globl _dfire_wait_PARM_1,_dfire_wait_PARM_2
	.globl _Cdfire_wait_PARM_2
	.globl _show_name_PARM_1

	.globl _set_equalizer_PARM_1
	.globl _set_equalizer_PARM_2
	.globl _set_equalizer_PARM_3

	.globl _dfire_start_cmd_PARM_1
	.globl _Cdfire_start_cmd_PARM_2
	.globl _dfire_start_cmd_PARM_2
	.globl _Cdfire_start_cmd_PARM_3
	.globl _dfire_start_cmd_PARM_3

	.globl _equalizer_PARM_1

	.globl _num_sub
	.globl _band3,_bandl,_bandl_can
	
	.globl _dfc_get_subch
	.globl _dfc_scan
	.globl _dfc_tune
	.globl _dfc_set_equalizer
	.globl _dfc_select_subch

	.globl _dfc_get_dabstatus
	.globl _lbmode

; Parameters

	.area DSEG    (DATA)
_get_dfire_PARM_1: 	.ds 1
_equalizer_PARM_1:
_transfer_frequ_PARM_1:	.ds 1

_dfire_wait_PARM_1:	.ds 1

_Cdfire_wait_PARM_2:
_dfire_wait_PARM_2:	.ds 1

_show_name_PARM_1:			;	.ds 1
_set_equalizer_PARM_1:	.ds 1
_set_equalizer_PARM_2:	.ds 1
_set_equalizer_PARM_3:	.ds 1
_dfire_start_cmd_PARM_1: .ds 1

_Cdfire_start_cmd_PARM_2:
_dfire_start_cmd_PARM_2: .ds 1

_Cdfire_start_cmd_PARM_3:
_dfire_start_cmd_PARM_3: .ds 1

; Variables

_dfire_wait_z_1_1:	.ds 1
_dfire_tune_c_1_1:	.ds 1
_get_subch_info_c:	.ds 1

	.area XSEG    (XDATA)

; -------------------------------------------------------------------

	.area ZEUG (ABS);
	.org 0x1b40

	END_LBANDH = 0x6b
	END_LBANDL = 0xec

	END_BAND3H = 0x3a
	END_BAND3L = 0x66

;	.area CSEG    (CODE)
; Channel -> frequency table
_bandl:	; 0-22
	 .byte 0x62,0xba , 0x63,0x25 , 0x63,0x90 , 0x63,0xfb  ; abcd
	 .byte 0x64,0x66 , 0x64,0xd1 , 0x65,0x3c , 0x65,0xa7  ; efgh
	 .byte 0x66,0x12 , 0x66,0x7d , 0x66,0xe8 , 0x67,0x53  ; ijkl
	 .byte 0x67,0xbe , 0x68,0x29 , 0x68,0x94 , 0x68,0xff  ; mnop
	 .byte 0x69,0x6a , 0x69,0xd5 , 0x6a,0x40 , 0x6a,0xab  ; qrst
	 .byte 0x6b,0x16 , 0x6b,0x81 , 0x6b,0xec , 0x62,0xba  ; uvwa

_band3:	;0-38
	 .byte 0x2a,0xb5 , 0x2b,0x20 , 0x2b,0x8b , 0x2b,0xf6  ; 5
	 .byte 0x2c,0x6b , 0x2c,0xd6 , 0x2d,0x41 , 0x2d,0xac  ; 
	 .byte 0x2E,0x20 , 0x2E,0x8B , 0x2E,0xF6 , 0x2F,0x61  ; 7
	 .byte 0x2F,0xD6 , 0x30,0x41 , 0x30,0xAC , 0x31,0x17 
	 .byte 0x31,0x8B , 0x31,0xF6 , 0x32,0x61 , 0x32,0xCC  ; 9
	 .byte 0x33,0x41 , 0x33,0xac , 0x34,0x17 , 0x34,0x82
	 .byte 0x34,0xf6 , 0x35,0x61 , 0x35,0xcc , 0x36,0x37  ; 11
	 .byte 0x36,0xac , 0x37,0x17 , 0x37,0x82 , 0x37,0xed 
	 .byte 0x38,0x58 , 0x38,0xc3 , 0x39,0x2e , 0x39,0x90  ; 13
	 .byte 0x39,0xfb , 0x3a,0x66 , 0x14,0x17 , 0x2a,0xb5

_bandl_can:	; 0-22
	 .byte 0x62,0xb1 , 0x63,0x1e , 0x63,0x8b , 0x63,0xf8  ; 1234
	 .byte 0x64,0x65 , 0x64,0xd2 , 0x65,0x3f , 0x65,0xac  ; 5678
	 .byte 0x66,0x19 , 0x66,0x86 , 0x66,0xf3 , 0x67,0x60  ; 9012 10
	 .byte 0x67,0xcd , 0x68,0x3a , 0x68,0xa7 , 0x69,0x14  ; 3456
	 .byte 0x69,0x81 , 0x69,0xee , 0x6a,0x5b , 0x6a,0xc8  ; 7890 20
	 .byte 0x6b,0x35 , 0x6b,0xa2 , 0x6c,0x0f , 0x62,0xba  ; 1234

; DFIRE-1 Commands
; Format: Length, data...

_dfc_get_subch:
	.byte 4,0x10,0x10,0x00,0x00
_dfc_scan:
	.byte 5,0x01,0x07,0x00,0x08,0x03
_dfc_tune:
	.byte 5,0x01,0x02,0x00,0x04,0x03
_dfc_set_equalizer:
	.byte 4,0x10,0x0c,0x00,0x03
_dfc_select_subch:
	;                            flags IF   OF    FN
	.byte 14,0x01,0x06,0x00,0x0b,0x08,0x01,0x00,0x03
	.byte    0x00,0x00,0x00,0x00,0x00,0x00
_dfc_get_dabstatus:
	.byte 4,0x01,0x0a,0x00,0x00

_dfc_config_dpram:
	.byte 5,0x10,0x20,0x00,0x01,0x01
	
_dfc_get_ms_audio:
	.byte 4,0x10,0x1b,0x00,0x00
; -------------------------------------------------------------------
	.area CSEG    (CODE)

; -------------------------------------------------------------------
; dfire_start_cmd (*char_dptr)

_dfire_start_cmd_dptr:
_Cdfire_start_cmd:
	mov _dfire_start_cmd_PARM_1,dpl
	mov _dfire_start_cmd_PARM_2,dph
_dfire_start_cmd:

	lcall _setz

	mov dpl,_dfire_start_cmd_PARM_1
	mov dph,_dfire_start_cmd_PARM_2
_dfsc0:
	movx a,@dptr
	mov r0,a ; length

	inc DPS
	mov dptr,#_cpubuf
	inc DPS
	mov r1,ar0
_dfsc1:
	inc dptr
	movx a,@dptr
	inc DPS
	movx @dptr,a
	inc dptr
	inc DPS
	djnz r1,_dfsc1

	mov dptr,#_cpubuf+3
	movx a,@dptr 		; length of parameter block
	add a,#4
	mov dptr,#_cd_free
	movx @dptr,a		; set free address

	mov dptr,#_dfire+BUFFPTR_DAB
	mov r0,#32
	ljmp _fill_mem0

; -------------------------------------------------------------------
_set_cd_msg:
	mov dptr,#_cd_msg
	mov a,#1
	movx @dptr,a
	ret
; -------------------------------------------------------------------
; dptr: addr, a: value, r0: count
_fill_mem0:
	clr a
_fill_mem:
	movx @dptr,a
	inc dptr
	djnz r0,_fill_mem
	ret
; -------------------------------------------------------------------
; void clear_sids(void)

_clear_sids:
	mov dptr,#_ensemble
	clr a
	movx @dptr,a

	mov r0,#32
	mov dptr,#_sids
	lcall _fill_mem0

	mov r0,#255
	mov dptr,#_names
	lcall _fill_mem0

	mov r0,#16
	mov _num_sub,r0
	mov dptr,#_subchannels
	lcall _fill_mem0

	mov dptr,#_bitrate_idx
	mov r0,#32
	ljmp _fill_mem0
; -------------------------------------------------------------------
_get_dfire_acc:
	mov dpl,a
	sjmp _get_dfire_dpl

;uchar get_dfire(uchar n)
_get_dfire:
	mov dpl,_get_dfire_PARM_1
_get_dfire_dpl:
	mov dph,#(_dfire+BUFFPTR_DAB>>8)
	movx a,@dptr
	mov dpl,a
	ret
; -------------------------------------------------------------------
; void setz(void)
_setz:
	mov dptr,#_cd_data
	mov r0,#4
	lcall _fill_mem0

	mov dptr,#_dfire+1023
	movx @dptr,a
	ret
; -------------------------------------------------------------------
; void transfer_frequ(uchar n)
_transfer_frequ:
	mov dptr,#_dfire+BUFFPTR_DAB
	mov dpl,_transfer_frequ_PARM_1
	movx a,@dptr
	anl a,#7
	mov r0,a
	inc dptr

	movx a,@dptr
	mov r1,a
	inc dptr

	movx a,@dptr
	mov r2,a
	
	mov dptr,#_frequ_h
	mov a,r0
	movx @dptr,a
	inc dptr

	mov a,r1
	movx @dptr,a
	inc dptr

	mov a,r2
	movx @dptr,a
	ret
; -------------------------------------------------------------------
; band/channel -> r5/r6/r7
_lookup_freq:
	mov a,_band
	jnz _lfq1
	mov r5,#0	
	mov dptr,#_band3
	sjmp _lfq2
_lfq1:
	mov r5,#1
	mov dptr,#_bandl
	mov a,_lbmode
	anl a,#1
	cjne a,#0,_lfq2		; lbmode=0 -> can
	mov dptr,#_bandl_can
_lfq2:
	mov a,_channel
	add a,acc
	add a,dpl
	mov dpl,a
	movx a,@dptr
	mov r6,a
	inc dptr
	movx a,@dptr
	mov r7,a
	ret
; -------------------------------------------------------------------
_blink:
	mov dptr,#OUTA
	movx a,@dptr
	xrl a,#0x80
	movx @dptr,a
	ret
; -------------------------------------------------------------------
; uchar dfire_wait(uchar waitc, uchar sub)
	.if 1
_Cdfire_wait:
	mov _dfire_wait_PARM_1,dpl
_dfire_wait:

	mov a,_supress_bar
	jnz _dfw1
	mov  a,_waiting1

	lcall _printf_index00_acc
_dfw1:	
	mov  r2,#0x00			; i=0 to timeout

dw_loop_i:
	mov  r6,#0x00			; n=0 to 31

dw_loop_n:

	push  ar2
	lcall  _dfire_get_msg
	pop  ar2

	mov  a,_msglen
	jz  l00115$			; msglen==0

	mov  dptr,#_dc_data
	movx  a,@dptr

	mov  r7,a
	mov  _dfire_wait_z_1_1,r7

	add  a,_msglen
	movx  @dptr,a

	mov  a,r7
	lcall  _get_dfire_acc
	mov  r0,a			; a=r0

	mov  a,r7
	inc a
	lcall  _get_dfire_acc
	mov  r7,a			; b=r7

	mov  a,r0
	cjne a,_dfire_wait_PARM_1,l00156$

	mov  a,_dfire_wait_PARM_2
	jz  dwait_end			; PARM2==0

	mov  a,r7
	cjne  a,_dfire_wait_PARM_2,l00156$
	ljmp  dwait_end

l00156$:
	cjne r0,#0x02,l00115$
	clr  c
	mov a,r7
	subb  a,#2
	jnc   dwait_end			; r7>1

l00115$:

	lcall  _wait_0_1ms
	lcall  _wait_0_1ms
	lcall  _wait_0_1ms

	inc  r6	
	cjne  r6,#0x20,dw_loop_n	; end for n

l00122$:
	inc  r2	
	mov a,_timeout
	cjne a,ar2,dw_loop_i

_dw_timed_out:
	mov  dpl,#0xff
	ret

dwait_end:
	mov  dpl,_dfire_wait_z_1_1
l00127$:
	.endif
	ret  
; -------------------------------------------------------------------
_get_subch_info_1:
	mov _get_subch_info_c,#3	; tries
	sjmp _gs0
_get_subch_info:
	mov _get_subch_info_c,#10	; tries
_gs0:
	mov  _waiting1,#STR_GINFO

;	mov r2,_num_sub			;
;	cjne r2,#0x10,_gsi1a

	mov  r2,#0x00			; subchannels[n]=n+1 for n=0...15
	mov dptr,#_subchannels
_gsi1:
	inc r2
	mov a,r2
	movx @dptr,a
	inc dptr
	cjne  r2,#0x10,_gsi1

	mov _num_sub,#0x10		; num_sub=16
_gsi1a:
	mov dptr,#_dfc_get_subch
	lcall _dfire_start_cmd_dptr	; issue get_subch();

	lcall _set_cd_msg
	
	mov _timeout,#40

	mov  _dfire_wait_PARM_1,#0x40
	mov  _dfire_wait_PARM_2,#0x00

	lcall  _dfire_wait              ; WAIT FOR DFIRE
	mov  r7,dpl			; r7: return pos

	mov dptr,#0x2000
	inc DPS
	mov dptr,#_dfire+BUFFPTR_DAB
	inc DPS
	mov r0,#192
	lcall _copybytes_loop		; copy answer to scratch


	mov  dpl,r7
	mov dph,#0x20
	movx a,@dptr

	cjne  a,#0x40,_gsi9		; answer != 0x40 

	inc dptr
	movx a,@dptr

	cjne  a,#0x10,_gsi9		; (answer+1) != 0x10 
	
	mov a,#4
	add a,r7			; m+4
	mov r7,a
	mov dpl,a
	movx a,@dptr
	mov  r6,a			; r6: num real subchannels
	mov _num_all,#0

	cjne r6,#0,_gsi2		; subchannels!=0
	sjmp _gsi9
_gsi2:
	inc r7				; r7: m+5
	mov r5,#0			; r5: n=0
			; LOOP r0 r5 r6 r7
_gsi3:
	mov dph,#0x20
	mov dpl,r7			; (i+0)= subchid
	movx a,@dptr
	mov r0,a

	mov dptr,#_all_subchannels
	mov dpl,_num_all
	movx @dptr,a			; store subch
	inc _num_all

	mov a,r7
	add a,#3
	mov dpl,a
	mov dph,#0x20
	movx a,@dptr
; DEBUG	
;	jb acc.0,_gsi4			; set if non-audio
					; Audio
	mov dpl,r7			; (i+0)= subchid
	movx a,@dptr
	mov r0,a

	mov dptr,#_subchannels
	mov a,dpl
	add a,r5
	mov dpl,a

	mov a,r0
	movx @dptr,a			; subchannels[n]=subchid

	mov a,r7
	add a,#4			; i+4
	mov dpl,a
	mov dph,#0x20
	movx a,@dptr
	mov r4,a
	
	inc dptr		; i+5
	movx a,@dptr
	mov r3,a

	mov dptr,#_bitrate_idx
	mov a,dpl
	add a,r5
	add a,r5			; +2*n
	mov dpl,a
	mov a,r4
	movx @dptr,a			; bitrate_idx[n][0]=(i+4)
	inc dptr
	mov a,r3
	movx @dptr,a 			; bitrate_idx[n][1]=(i+5)
	
	inc r5				; n++
	
	cjne r5,#0x10,_gsi4		; >=16 subchannels
	mov _num_sub,r5
	ret
_gsi4:
	mov a,r7
	add a,#7
	mov r7,a

	djnz r6,_gsi3

	mov _num_sub,r5
	cjne r5,#0x10,_gsi10
	sjmp _gsi9
_gsi10:
	ret
_gsi9:
;	lcall _wait_1000
	dec _get_subch_info_c
	mov a,_get_subch_info_c
	jz _gsi10
	ljmp _gsi1a
	
; -------------------------------------------------------------------
_show_num_subch:
	lcall _clr_line1
	mov a,#STR_CHANNELS   ; channels:
	lcall _printf_index01_acc
	mov a,_num_sub
	ljmp _printi_acc1
; -------------------------------------------------------------------
	.if 1
_dfire_get_msg:

	mov  dptr,#_dc_data
	movx  a,@dptr
	mov  r2,a

	inc dptr	; dc_free
	movx  a,@dptr
	mov  r3,a

	clr  c
	mov  a,r2
	subb  a,r3
	mov  r3,a

	cjne r3,#0x00,00102$

	mov  _msglen,#0x00
	ret
00102$:

	mov  a,r2
	lcall  _get_dfire_acc
	cjne a,#0x02,00104$
	sjmp 00106$			 msglen=2
00104$:

	cjne a,#0x04,00118$

	mov  a,r2
	inc acc
	lcall  _get_dfire_acc

	cjne  a,#0x06,00139$
	sjmp 00105$
00139$:
	cjne  a,#0x07,00140$
	sjmp 00105$
00140$:
	cjne  a,#0x08,00141$
	sjmp 00105$
00141$:
	cjne  a,#0x0a,00142$
	sjmp 00105$
00142$:
	cjne  a,#0x0b,00143$
	sjmp 00105$
00143$:
	cjne  a,#0x0d,00144$
	sjmp 00105$
00144$:
	cjne  a,#0x12,00145$
	sjmp 00105$
00145$:
	cjne  a,#0x1d,00146$
	sjmp 00105$
00146$:
	cjne  a,#0x16,00147$
	sjmp 00105$
00147$:
	cjne a,#0x1e,00106$
00105$:
	mov  a,#0x03
	add  a,r2
	lcall  _get_dfire_acc
	add  a,#4
	mov  _msglen,a
	ret
00106$:
00118$:
	mov  _msglen,#0x02
	ret

	.endif
; -------------------------------------------------------------------
; -------------------------------------------------------------------
;void init_control(void)
_init_control:
	lcall _clear_sids
	mov dptr,#_ensemble
	clr a
	movx @dptr,a
	ljmp _setz	

; -------------------------------------------------------------------

_show_bank_leds:
	mov r0,#0
	mov r1,#0

	mov a,_timer_n
	jnb acc.4,_sbl0
	mov a,_bank
	anl a,#0xf0
	jnz _sbl6
	ret
_sbl0:
        mov a,_bank
        anl a,#3

        cjne a,#0,_sbl1
        mov r0,#0x40
        sjmp _sbl6
_sbl1:
        cjne a,#1,_sbl3
        mov r0,#0x80
	sjmp _sbl6
_sbl3:
        cjne a,#2,_sbl4
        mov r1,#0x10
        sjmp _sbl6
_sbl4:
        cjne a,#3,_sbl6
        mov r1,#0x20
_sbl6:
	mov dptr,#OUTA
	movx a,@dptr
	anl a,#0x3f
	orl a,r0
	movx @dptr,a

	mov dptr,#OUTC
	movx a,@dptr
	anl a,#0xcf
	orl a,r1
	movx @dptr,a
        ret

; -------------------------------------------------------------------
_show_channel:
	mov a,_band
	jnz _sch_l
	mov a,_channel
	jb acc.5,_sch_xxx
	rr a
	rr a
	anl a,#31
	add a,#5
	lcall _printi_acc2
	mov a,_channel
	anl a,#3
	sjmp _sch_yyy
_sch_xxx:			; band3
	mov a,#13
	lcall _printi_acc1
	mov a,_channel
	anl a,#31
_sch_yyy:			; suffix
	add a,#'A
	ljmp _putc_acc
_sch_l:
	mov a,_lbmode
	anl a,#1
	mov r7,a
	cjne r7,#1,_sc_lcan0	
;	lcall _putc32
_sc_lcan0:
	mov a,#'L
	lcall _putc_acc
	cjne r7,#1,_sc_lcan	; 1->ETSI
	mov a,_channel
	add a,#'A
	ljmp _putc_acc
_sc_lcan:			; canadian number
	mov a,_channel	
	inc a
	ljmp _printi_acc2
; -------------------------------------------------------------------
; void show_prognum(void)
_show_prognum:
	mov a,_storage
	add a,#1
	jz no_bank
	mov a,_menu
	cjne a,#1,_shn2aa		; suppress bank mapping for Q-display
no_bank:
	mov a,#'P
	lcall _putc_acc
	mov a,_subch
	inc acc
_shn2b:

	ljmp _printi_acc2
_shn2aa:
	mov a,_storage
	dec a
	mov b,#6
	div ab
	add a,#'A
	lcall _putc_acc
	
	mov a,b
	inc a
	sjmp _shn2b

; -------------------------------------------------------------------
; void show_name(uchar n)
_Cshow_name:
	mov _show_name_PARM_1,dpl
_show_name:
	lcall _clr_line0
	mov dptr,#_ensemble
	movx a,@dptr
	jz _shn1
	mov a,#STR_ENSEMBLE	; ensemble
	lcall _printf_index00_acc
	sjmp _shn2
_shn1:
	lcall _show_channel
_shn2:
;	lcall _show_prognum013

_show_name_raw:
	mov a,_current_subch
	inc a
	jz no_clear		; =255

	lcall _clr_line1

no_clear:
	lcall _poscursor01

	mov a,_show_name_PARM_1
	lcall _calc_name_addr_dptr

	movx a,@dptr
	jnz _shn3
	mov a,_show_name_PARM_1
	lcall _get_sid
	mov a,r1
	orl a,r0
	jz _shn2a

	lcall _show_sid
_shn2a:
	ret
_shn3:
	mov a,_show_name_PARM_1
	lcall _calc_name_addr_dptr

	mov _printf_PARM_1,dpl
	mov (_printf_PARM_1+1),dph
	ljmp _printf


; -------------------------------------------------------------------
;void dfire_tune(void)
_dfire_tune:
	mov _quality_mode,#0x00
	lcall _setz
	mov r0,#9
	mov r1,#0
	lcall _poscursor_r01
	lcall _show_channel
	lcall _clear_sids	

	mov _waiting1,#STR_TUNING	; TUNING

	lcall _lookup_freq	; ->r5/r6/r7

	mov dptr,#_dfc_tune
	lcall _dfire_start_cmd_dptr
	
	mov dptr,#_cpubuf+5
	mov a,r5
	movx @dptr,a		; 5: a 

	inc dptr
	mov a,r6
	movx @dptr,a		; b

	inc dptr
	mov a,r7
	movx @dptr,a		; c

	ljmp _set_cd_msg

; -------------------------------------------------------------------
; a: value, r7: modulo	; assumes only "one" wraparound, r6: r6+1,0,-1
_modulo_x:
	jnb acc.7,_mx1
	add a,r7
	dec r6
	ret
_mx1:
	cjne a,ar7,_mx2
_mx2:
	jnc _mx3		; >=r7
	ret
_mx3:	
	clr c
	subb a,r7
	inc r6
	ret
; -------------------------------------------------------------------
; r7: value :02i
_show_colon_printi:
	mov a,#':
	lcall _putc_acc
	mov a,r7
	ljmp _printi_acc2

; -------------------------------------------------------------------
_show_time:
	lcall _clr_line0

	mov r0,#0
	mov r3,#0
	mov r6,_hour
	mov a,_utc_off
	jnb acc.0,_no_30min
	mov r0,#30
	mov r3,#30
	jnb acc.5,_no_30min
	mov r0,#-30
_no_30min:
	push ar3
	mov a,_min

	add a,r0
	mov r7,#60
	acall _modulo_x

	mov r2,a		; r2: min

	mov a,_utc_off
	rr a
	jnb acc.4,_sht1
	anl a,#15
	xrl a,#255
	inc a
	mov r4,#'-
	sjmp _sht2
_sht1:
	anl a,#15
	mov r4,#'+
_sht2:
	push ar4
	add a,r6		; off+hour
	mov r7,#24
	acall _modulo_x

	push ar2
	lcall _printi_acc2

	pop ar7
	acall _show_colon_printi

	mov r7,_sec
	acall _show_colon_printi

	lcall _putc32

	pop ar4


	mov a,r4
	lcall _putc_acc

	mov a,_utc_off
	rr a
	anl a,#15
	lcall _printi_acc2

	pop ar7 ; ex r3
	acall _show_colon_printi

	ret
; -------------------------------------------------------------------
; dabstatus +8: sync-state +9: quality
;
;
;void show_dabstate()
	.if 1
_show_dabstate:
	mov a,_menu
	jz _sds0
	mov a,_quality_mode
	jz _sds0
	cjne a,#1,_sds01
	lcall _show_time
_sds00:
	lcall _show_name_raw
	ret
_sds01:

	lcall _get_audio_info
	sjmp _sds00
_sds0:
	mov _waiting1,#STR_NULL	; SPC_NULL

	mov _quality,#7

	mov r7,#2
_sds1:
	push ar7
_sds1a:
	lcall _get_dab_status
	
	mov _dfire_wait_PARM_1,#4
	mov _dfire_wait_PARM_2,#0xa
	lcall _dfire_wait
	mov r6,dpl			; r6: datapos
	cjne r6,#255,_sds1b
	sjmp _sds1a
_sds1b:
	push ar6

	mov a,dpl
	add a,#5
	mov _transfer_frequ_PARM_1,a
	lcall _transfer_frequ
	lcall _search_channel
	
	pop acc
	push acc
	add a,#9
	lcall _get_dfire_acc			; m+9

	swap a
	anl a,#15
	mov _quality,a
	
	;----------------------------- Print quality

	lcall _clr_line1

	mov a,#'Q
	lcall _putc_acc

	mov a,_quality
	lcall _printi_acc1			

	;----------------------------- Print quality bar

	mov _bargraph_PARM_1,#12	
	mov _bargraph_PARM_2,#3	
	mov _bargraph_PARM_3,#3
	lcall _bargraph

	mov a,_quality
	cpl a
	add a,#8
	rl a
	anl a,#15
	mov _bargraph_PARM_1,a
;	mov _bargraph_PARM_2,#3	
	mov _bargraph_PARM_3,#1
	lcall _bargraph

	;----------------------------- Print channel
	lcall _poscursor00
	mov _print_spaces_PARM_1,#13	; 13 SPC
	lcall _print_spaces

	mov r0,#9
	mov r1,#0
	lcall _poscursor_r01
	lcall _show_channel
	lcall _putc32

	pop ar6

	mov a,_menu			; extra infos?
	jz _sds3

	;----------------------------- Print Sync state

	mov r0,#10
	mov r1,#1
	lcall _poscursor_r01
		
	push ar6
	mov a,r6
	add a,#8			; m+8
	lcall _get_dfire_acc
	lcall _printi_acc1
	
	;------------------------------ print SID
	lcall _putc32

	mov a,_subch
	lcall _get_sid
	lcall _show_sid

	;----------------------------- Print bitrate

	lcall _poscursor00

	mov dptr,#_bitrate_idx
	mov a,_subch
	add a,acc
	add a,dpl
	mov dpl,a
	movx a,@dptr

	mov b,#8 ;; FIXME
	mul ab
	jnb b.0,no_256
;	lcall_printi16_acc1
no_256:
	lcall _printi_acc1
	
	mov a,#'k
	lcall _putc_acc
	lcall _putc32

	;----------------------------- Print Transmission mode

	mov a,#'T
	lcall _putc_acc

	pop ar6
	mov a,r6
	add a,#5
	lcall _get_dfire_acc		; m+5

	swap a
	anl a,#7
	lcall _printi_acc1

	;----------------------------- Print Mute info
	lcall _putc32
	mov a,r6
	add a,#9			; m+9
	lcall _get_dfire_acc
	anl a,3
	lcall _printi_acc1
	
	;------------------------------

;	inc dptr
;	movx a,@dptr
;	mov _printh_PARM_1,a		; Tableindex
;	lcall _printh

_sds3:
	pop ar7
	mov a,_quality

	add a,#251	; quality>4
	jnc _sds4
	
	djnz r7,_sds5
_sds4:
	ret
_sds5:
	lcall _wait_3000
	ljmp _sds1
	.endif	
; -------------------------------------------------------------------
; -------------------------------------------------------------------
_decrement_subch:
	mov a,_subch
	dec a
	sjmp _ish0

_increment_subch:
	mov a,_subch
	inc a
_ish0:
	mov _subch,a
	cjne a,#255,_ish1
	mov a,_num_sub
	jz _ish2
	dec a
_ish2:
	mov _subch,a
	sjmp _ish3
_ish1:
	mov a,_num_sub
	clr c
	subb a,_subch
	jnz _ish3
	mov _subch,#0
_ish3:
	mov a,_subch
	anl a,#15
	mov _subch,a
;	mov _select_prog_PARM_1,a
	push acc
	lcall _find_banked
	mov _storage,dpl
	pop dpl
	mov _select_prog_PARM_2,#0
	ljmp _select_prog

; -------------------------------------------------------------------
; -------------------------------------------------------------------
;void acquire_figs()

_acquire_figs:

	lcall _parse_all_figs
 .if 1
	mov dptr,#_dfire
	mov r0,#192
	mov a,#0
_acf:
	movx @dptr,a
	inc dptr
	movx @dptr,a
	inc dptr
	djnz r0,_acf

	mov dptr,#_dfc_config_dpram
	lcall _dfire_start_cmd_dptr		; issue get_subch();
	lcall _set_cd_msg
	ret

; -------------------------------------------------------------------
_dfire_wait_4_0:
	mov _dfire_wait_PARM_1,#4
	mov _dfire_wait_PARM_2,#0
	ljmp _dfire_wait
	
; -------------------------------------------------------------------
_set_equalizer:

	push ar0
	push ar1
	push ar2
	lcall _setz
	mov _waiting1,#STR_NULL

	mov dptr,#_dfc_set_equalizer
	lcall _dfire_start_cmd_dptr

	mov dptr,#_cpubuf+4
	mov a,_set_equalizer_PARM_1 ; 4: start band
	movx @dptr,a

	inc dptr
	mov a,_set_equalizer_PARM_2 ; stop band
	movx @dptr,a	

	inc dptr
	mov a,_set_equalizer_PARM_3 ; val
	movx @dptr,a

	lcall _set_cd_msg

	mov _timeout,#15
	mov  _dfire_wait_PARM_1,#0x40
	mov  _dfire_wait_PARM_2,#0x00
	lcall  _dfire_wait
	pop ar2
	pop ar1
	pop ar0
	ret

; -------------------------------------------------------------------
_print_current_name:

	mov a,#STR_CURRENT_NAME
	ljmp _printf_index_acc
; -------------------------------------------------------------------
; equalizer (uchar show)
_equalizer:	
	mov r4,_eq_val
	mov r5,0x0001 + _eq_val
	mov r6,0x0002 + _eq_val

        clr     c
        mov     a,r4
        subb    a,r5
        jc   _eq1
        clr     c
        mov     a,r4
        subb    a,r6
        jc   _eq1
        mov     r3,ar4		; BASS
        sjmp _eq3

_eq1:
        clr     c
        mov     a,r5
        subb    a,r4
        jc   _eq2

        clr     c
        mov     a,r5
        subb    a,r6
        jc   _eq2

        mov     r3,ar5	; MID
        sjmp _eq3

_eq2:
        mov     r3,ar6	; TREBLE

_eq3:
        clr     c
        mov     a,r3
        subb    a,r4
        cpl  a
        mov  r0,a
        clr     c
        mov     a,r3
        subb    a,r5
        cpl  a
        mov  r1,a
        clr     c
        mov     a,r3
        subb    a,r6
        cpl  a
        mov  r2,a
        mov     r5,_equalizer_PARM_1
        mov     a,r5
        jb   acc.7,_eq4

	clr a
        mov     _set_equalizer_PARM_1,a
        mov     _set_equalizer_PARM_2,a
        mov     _set_equalizer_PARM_3,r0
        lcall   _set_equalizer

        inc     _set_equalizer_PARM_1
        mov     _set_equalizer_PARM_2,#0x02
        mov     _set_equalizer_PARM_3,r1
        lcall   _set_equalizer

        mov     _set_equalizer_PARM_1,#0x03
        mov     _set_equalizer_PARM_2,#0x1D
        mov     _set_equalizer_PARM_3,r2
        lcall   _set_equalizer

_eq4:

        mov     a,_supress_bar

        jnz  _eq5

        mov     _bargraph_PARM_1,#0x10
        mov     _bargraph_PARM_2,#0x04
        mov     _bargraph_PARM_3,#0x03
        lcall   _bargraph

	mov a,_equalizer_PARM_1
	anl a,#0x03
	add     a,#_eq_val
	mov r0,a
	mov     a,@r0
	swap    a
        anl     a,#0x0f
	inc a        
        mov     _bargraph_PARM_1,a
;        mov     _bargraph_PARM_2,#0x04
        mov     _bargraph_PARM_3,#0x01
        lcall   _bargraph
_eq5:

        ret
; -------------------------------------------------------------------
_setup_xscan:
; -------------------------------------------------------------------
_setup_scan:
	mov a,_band
	jnz _ssn1		; Band 3
	mov a,_channel
	add a,acc	; *2
	mov dptr,#_band3

	mov r3,#0	; a/aa, 
	mov r2,#1	; r2=1-> Band3
	sjmp _ssn2

_ssn1:
	mov r2,#2
	mov dptr,#_bandl
	mov a,_lbmode
	anl a,#1
	cjne a,#0,_ssn1a	; LBAND CEPT
	mov dptr,#_bandl_can
	mov r2,#3
_ssn1a:
	mov a,_channel
	add a,acc	; *2
	mov r3,#1	; a/aa
_ssn2:	
	add a,dpl
	mov dpl,a

	mov r0,#4
_ssn2l:	
	movx a,@dptr
	mov @r0,a	; b-d: r4-r7	; channel r4/r5, (channel+1) r6/r7
	inc dptr
	inc r0
	cjne r0,#8,_ssn2l

	mov dptr,#_dfc_scan
	lcall _dfire_start_cmd_dptr

	mov dptr,#_cpubuf+5
	mov a,r3
	movx @dptr,a		; 5:a

	inc dptr
	mov a,r6
	movx @dptr,a		; 6:b

	inc dptr
	mov a,r7
	movx @dptr,a		; 7:cc

	inc dptr
	mov a,r3
	orl a,#0x30
	movx @dptr,a		; 8: a|0x30

	inc dptr
	mov a,r4
	movx @dptr,a		; 9: bb

	inc dptr
	mov a,r5
	movx @dptr,a		; 10: cc

	inc dptr
	mov a,r2
	movx @dptr,a		; 11: d		band3/L-band
	ret
; -------------------------------------------------------------------
; -------------------------------------------------------------------
; returns a=1: finished
_scan_next_sub:
	mov _quality_mode,#0
	lcall _wait_3000
	lcall _get_dab_status
	lcall _dfire_wait_4_0
	mov a,dpl
	mov r6,a			; r6: pos of message

	cjne a,#255,_sns2
	sjmp _scan_not_finished		; no message

_sns2:
	mov _get_dfire_PARM_1,a
	lcall _get_dfire
	mov r0,a

	inc _get_dfire_PARM_1
	lcall _get_dfire
	mov r1,a

	cjne r0,#4,_scan_not_finished
	cjne r1,#7,_sns2a

	mov a,r6			; scan_notify
	add a,#4
	mov _transfer_frequ_PARM_1,a
	lcall _transfer_frequ
	sjmp _scan_not_finished

_sns2a:	
	cjne r1,#0xa,_scan_not_finished		; dab_status_notify

	mov a,r6			; get status msg
	add a,#5
	mov _transfer_frequ_PARM_1,a
	lcall _transfer_frequ
	lcall _search_channel		; show freq

	mov a,_channel
	cjne a,_start_channel,_sns2b	; scan wrapped around?
_scan_finished:
	lcall _search_channel
	lcall _show_frequency
	mov a,#1
	ret
_sns2b:
	mov a,_transfer_frequ_PARM_1
	add a,#4
	mov _get_dfire_PARM_1,a
	lcall _get_dfire		; get quality
	swap a
	anl a,#0x0f
	jz _scan_not_finished		; 0: error
	cjne  a,#0x05,_sns2ba		; quality <5
_sns2ba:
	jnc _scan_not_finished		; >=5
	
	dec _get_dfire_PARM_1
	lcall _get_dfire
	anl a,#0xf
	cjne    a,#7,_scan_not_finished		; sync?
	sjmp _scan_finished
	
_scan_not_finished:
	lcall _search_channel
	lcall _show_frequency
	mov a,#0
	ret

; -------------------------------------------------------------------
_scan_next:
	lcall _setup_scan

	lcall _set_cd_msg

	mov _waiting1,#STR_SCAN

	mov _start_channel,_channel

	mov r7,#200
_sn1:
	push ar7
	lcall _scan_next_sub
	jz _sn4			; not finished
	lcall _scan_next_sub
	jz _sn4
	lcall _scan_next_sub
	jz _sn4
	pop ar7
	ret
_sn4:
	pop ar7
	djnz r7,_sn5
	ret
_sn5:
	ljmp _sn1
; -------------------------------------------------------------------
_show_frequency:
	mov r0,#9
	mov r1,#0
	lcall _poscursor_r01
	lcall _show_channel

	mov r0,#7
	mov r1,#1
	lcall _poscursor_r01
	mov _print_spaces_PARM_1,#9
	lcall _print_spaces
	mov a,_channel
	rr a
	anl a,#127
	mov _bargraph_PARM_1,a
	mov _bargraph_PARM_2,#7
	mov _bargraph_PARM_3,#1
	ljmp _bargraph
; -------------------------------------------------------------------
; select subchannel in A for RDI
_rdi_select_one:
	push acc
	mov dptr,#_dfc_select_subch
	lcall _dfire_start_cmd_dptr

	mov dptr,#_cpubuf+6
	mov a,#1
	movx @dptr,a
	inc dptr

	mov a,#2
	movx @dptr,a
	
	pop acc
	mov dptr,#_cpubuf+14
	movx @dptr,a

;	mov _printh_PARM_1,a
;	lcall _printh
	lcall _set_cd_msg
	mov _supress_bar,#1
	mov  _dfire_wait_PARM_1,#0x4
	mov  _dfire_wait_PARM_2,#0x0
	mov _timeout,#20
	lcall  _dfire_wait
	mov _supress_bar,#0
	ret
; -------------------------------------------------------------------
_rdi_select_all:
	mov r0,_select_rdi_cnt
	mov dptr,#_all_subchannels
	mov dpl,r0
	movx a,@dptr
	lcall _rdi_select_one
	inc _select_rdi_cnt
	mov a,_num_all
	cjne a,_select_rdi_cnt,_rsa_end
	mov _select_rdi_cnt,#0
_rsa_end:
	ret	
; -------------------------------------------------------------------
_get_audio_info:
	mov dptr,#_dfc_get_ms_audio
	lcall _dfire_start_cmd_dptr
	lcall _set_cd_msg
	mov _supress_bar,#1
	mov  _dfire_wait_PARM_1,#0x40
	mov  _dfire_wait_PARM_2,#0x1b
	mov _timeout,#60
	lcall  _dfire_wait
		
	mov a,dpl
	mov r7,a
	lcall _get_dfire_acc
	cjne a,#0x40,_gai_end
	mov a,r7
	add a,#10
	lcall _get_dfire_acc
	jb acc.0,_is_24khz
	mov r7,#48
	sjmp _gai0
_is_24khz:
	mov r7,#24
_gai0:
	
	lcall _clr_line0
	mov a,r7
	lcall _printi_acc1
	mov a,#'k
	lcall _putc_acc
	mov a,#'H
	lcall _putc_acc
	mov a,#'z
	lcall _putc_acc
_gai_end:
	ret
