; EZ-USB register definition
; 26.6.99 GA
 
IN0BUF		= 0x7f00
IN1BUF		= 0x7e80
IN2BUF		= 0x7e00
IN3BUF		= 0x7d80
IN4BUF		= 0x7d00
IN5BUF		= 0x7c80
IN6BUF		= 0x7c00
IN7BUF		= 0x7b80
OUT0BUF		= 0x7ec0
OUT1BUF		= 0x7e40
OUT2BUF		= 0x7dc0
OUT3BUF		= 0x7d40
OUT4BUF		= 0x7cc0
OUT5BUF		= 0x7c40
OUT6BUF		= 0x7bc0
OUT7BUF		= 0x7b40

OUTB8BCH	= 0x7f70
OUTB8BCL	= 0x7f71
OUTB9BCH	= 0x7f72
OUTB9BCL	= 0x7f73
OUTB10BCH	= 0x7f74
OUTB10BCL	= 0x7f75
OUTB11BCH	= 0x7f76
OUTB11BCL	= 0x7f77
OUTB12BCH	= 0x7f78
OUTB12BCL	= 0x7f79
OUTB13BCH	= 0x7f7a
OUTB13BCL	= 0x7f7b
OUTB14BCH	= 0x7f7c
OUTB14BCL	= 0x7f7d
OUTB15BCH	= 0x7f7e
OUTB15BCL	= 0x7f7f


CPUCS		= 0x7f92
PORTACFG	= 0x7f93
PORTBCFG	= 0x7f94
PORTCCFG	= 0x7f95
OUTA		= 0x7f96
OUTB		= 0x7f97
OUTC		= 0x7f98
PINSA		= 0x7f99
PINSB		= 0x7f9a
PINSC		= 0x7f9b
OEA		= 0x7f9c
OEB		= 0x7f9d
OEC		= 0x7f9e
ISOERR		= 0x7fa0
ISOCTL		= 0x7fa1
ZBCOUT		= 0x7fa2
I2CS		= 0x7fa5
I2DAT		= 0x7fa6
IVEC		= 0x7fa8
IN07IRQ		= 0x7fa9
OUT07IRQ	= 0x7faa
USBIRQ		= 0x7fab
IN07IEN		= 0x7fac
OUT07IEN	= 0x7fad
USBIEN		= 0x7fae
USBBAV		= 0x7faf
BPADDRH		= 0x7fb2
BPADDRL		= 0x7fb3

EP0CS		= 0x7fb4
IN0BC		= 0x7fb5
IN1CS		= 0x7fb6
IN1BC		= 0x7fb7
IN2CS		= 0x7fb8
IN2BC		= 0x7fb9
IN3CS		= 0x7fba
IN3BC		= 0x7fbb
IN4CS		= 0x7fbc
IN4BC		= 0x7fbd
IN5CS		= 0x7fbe
IN5BC		= 0x7fbf
IN6CS		= 0x7fc0
IN6BC		= 0x7fc1
IN7CS		= 0x7fc2
IN7BC		= 0x7fc3


OUT0BC		= 0x7fc5
OUT1CS		= 0x7fc6
OUT1BC		= 0x7fc7
OUT2CS		= 0x7fc8
OUT2BC		= 0x7fc9
OUT3CS		= 0x7fca
OUT3BC		= 0x7fcb
OUT4CS		= 0x7fcc
OUT4BC		= 0x7fcd
OUT5CS		= 0x7fce
OUT5BC		= 0x7fcf
OUT6CS		= 0x7fd0
OUT6BC		= 0x7fd1
OUT7CS		= 0x7fd2
OUT7BC		= 0x7fd3

SUDPTRH		= 0x7fd4
SUDPTRL		= 0x7fd5
USBCS		= 0x7fd6
TOGGCTL		= 0x7fd7
USBFRAMEL	= 0x7fd8
USBFRAMEH	= 0x7fd9
FNADDR		= 0x7fdb
USBPAIR		= 0x7fdd
IN07VAL		= 0x7fde
OUT07VAL	= 0x7fdf
INISOVAL 	= 0x7fe0
OUTISOVAL	= 0x7fe1
FASTXFR		= 0x7fe2
AUTOPTRH	= 0x7fe3
AUTOPTRL	= 0x7fe4
AUTODATA	= 0x7fe5
SETUPBUF	= 0x7fe8

OUT8ADDR	= 0x7ff0
OUT9ADDR	= 0x7ff1
OUT10ADDR	= 0x7ff2
OUT11ADDR	= 0x7ff3
OUT12ADDR	= 0x7ff4
OUT13ADDR	= 0x7ff5
OUT14ADDR	= 0x7ff6
OUT15ADDR	= 0x7ff7
IN8ADDR		= 0x7ff8
IN9ADDR		= 0x7ff9
IN10ADDR	= 0x7ffa
IN11ADDR	= 0x7ffb
IN12ADDR	= 0x7ffc
IN13ADDR	= 0x7ffd
IN14ADDR	= 0x7ffe
IN15ADDR	= 0x7fff

OUT8DATA	= 0x7f60
OUT0DATA	= 0x7f61
OUT10DATA	= 0x7f62
OUT11DATA	= 0x7f63
OUT12DATA	= 0x7f64
OUT13DATA	= 0x7f65
OUT14DATA	= 0x7f66
OUT15DATA	= 0x7f67
IN8DATA		= 0x7f68
IN9DATA		= 0x7f69
IN10DATA	= 0x7f6a
IN11DATA	= 0x7f6b
IN12DATA	= 0x7f6c
IN13DATA	= 0x7f6d
IN14DATA	= 0x7f6e
IN15DATA	= 0x7f6f

SP		= 0x81
DPL		= 0x82
DPH		= 0x83
DPL1		= 0x84
DPH1		= 0x85
DPS		= 0x86
PCON		= 0x87
TCON		= 0x88
TMOD		= 0x89
TL0		= 0x8a
TL1		= 0x8b
TH0		= 0x8c
TH1		= 0x8d
CKCON		= 0x8e
SPC_FNC		= 0x8f
EXIF		= 0x91
MAPGE		= 0x92
SCON0		= 0x98
SBUF0		= 0x99
IE		= 0xa8
IP		= 0xb8
SCON1		= 0xc0
SBUF1		= 0xc1
T2CON		= 0xc8
RCAP2L		= 0xca
RCAP2H		= 0xcb
TL2		= 0xcc
TH2		= 0xcd
PSW		= 0xd0
EICON		= 0xd8
EIE		= 0xe8
B		= 0xf0
EIP		= 0xf8

