// variables_a.h 290500 GA
//
// Variables in external memory (STANDALONE)
//
// $Id: variables_a.h,v 1.7.2.8 2003/06/23 15:54:22 acher Exp $

// Software stuff

extern uchar nvram_bank;
extern uchar nvram_addr;
extern uchar nvram_val;

// Memory for possible exchange with USB
// located in unsed IN1/OUT1 buffer



xdata at 0x1e40 uchar volume[32]; 
xdata at 0x1e60 uchar frequ_h;
xdata at 0x1e61 uchar frequ_m;
xdata at 0x1e62 uchar frequ_l;

xdata at 0x1e66 uchar xchange_valid;
xdata at 0x1e80 uchar subchannels[16];
xdata at 0x1e90 uchar ensemble[17];

// STANDALONE RAM ONLY (ISO buffer otherwise)

xdata at 0x2300 uchar all_subchannels[64];
xdata at 0x2340 uchar secondary[64];

xdata at 0x2400 uchar bitrate_idx[16][2];
//xdata at 0x2500 uchar ensembles[64][2];


/* scratch layout:
0 my_subchannel
1 band
2 channel
3 storage
4 bank
5 sidl 
6 sidh

16-31 name
*/

xdata at 0x2500 uchar scratch0[32];
xdata at 0x2520 uchar scratch1[32];
xdata at 0x2540 uchar scratch2[32];
xdata at 0x2560 uchar scratch3[32];

xdata at 0x2580 uchar current_name[16];

xdata at 0x25d0 uchar sids[16][2];
xdata at 0x2600 uchar dynlab0[128];
xdata at 0x2680 uchar dynlab1[128];
xdata at 0x2700 uchar names[16][16];

#include "hw_variables.h"
